/* ----------------------------------------------------------------------------
 * GuluWin - The File Searching and Batch Processing Expert
 * Copyright (C) 2007-2008 SunnyChen.ORG, all rights reserved.
 *
 * Gulu Script - Simple Script
 * 
 * Name          : Sample_Output
 * Author        : Sunny Chen
 * Company       : SunnyChen.ORG
 * Version       : 1.0
 * Date          : 2008-6-3
 * 
 * This is an example of the Gulu that outputs the file name for each
 * encountered file.
 * 
 * UPDATE HISTORY
 * ----------------------------------------------------------------------------
 * DATE          DESCRIPTION                            VERSION      UPDATED_BY
 * 
 * ---------------------------------------------------------------------------- */

using System;
using System.Drawing;

using SunnyChen.Gulu.Gulus;
using SunnyChen.Gulu.Environment;
 
public class Sample_Output_Gulu : GuluBase
{
	public override bool Execute(string _param)
    {
		Output.Add(_param);
		return true; 
    } 
   
	#region Gulu Attributes
    public override string Name
    {
        get { return "Sample_Output"; }
    }

    public override string Category
    {
        get { return "Sample G Script"; }
    }

    public override string Description
    {
        get { return @"This is an example of the Gulu that outputs 
        the file name for eachencountered file."; }
    }

    public override DateTime CreatedDate
    {
        get 
        {
            DateTime date = DateTime.Now;
            DateTime.TryParse("2008-6-3", out date);
            return date;
        }
    }

    public override string Author
    {
        get { return "Sunny Chen"; }
    }

    public override string Version
    {
        get { return "1.0"; }
    }

    public override string Company
    {
        get { return "SunnyChen.ORG"; }
    }

    public override string Copyright
    {
        get { return "Copyright (C) 2007-2008 SunnyChen.ORG, all rights reserved."; }
    }

    public override Bitmap Image
    {
        get 
        { 
        	// Image attribute is meaningless in the gulu script.
        	// Just returns NULL value here.
        	return null; 
        }
    }

    public override bool BackupRequired
    {
        get 
        { 
        	return true; 
        }
    }
    #endregion

	#region Initialization and Finalization
    public override bool Init()
    {
        // TODO: Place your initialization code here.
        return true;
    }
    
    public override bool Done()
    {
    	// TODO: Place your finalization code here.
    	Output.Add(string.Format("Session Elapsed: {0}", Session.CurrentSession.TimeElapsed));
        return true;
    }
    #endregion
}

#region Script Entry Point
public class Program
{
 	public static void Main()
 	{
 		GuluRunner.Run(new Sample_Output_Gulu());
 	}
}
#endregion
